# class SQLite3::FunctionProxy

A helper class for dealing with custom functions (see create_function, create_aggregate, and create_aggregate_handler). It encapsulates the opaque function object that represents the current invocation. It also provides more convenient access to the API functions that operate on the function object.

This class will almost always be instantiated indirectly, by working with the create methods mentioned above.

### Attributes

result[RW]

### Public Class Methods

new() click to toggle source

Create a new FunctionProxy that encapsulates the given `func` object. If context is non-nil, the functions context will be set to that. If it is non-nil, it must quack like a Hash. If it is nil, then none of the context functions will be available.

    # File lib/sqlite3/database.rb, line 551
    def initialize
      @result   = nil
      @context  = {}
    end

### Public Instance Methods

[]( key ) click to toggle source

Returns the value with the given key from the context. This is only available to aggregate functions.

    # File lib/sqlite3/database.rb, line 571
    def []( key )
      @context[ key ]
    end

[]=( key, value ) click to toggle source

Sets the value with the given key in the context. This is only available to aggregate functions.

    # File lib/sqlite3/database.rb, line 577
    def []=( key, value )
      @context[ key ] = value
    end

count() click to toggle source

(Only available to aggregate functions.) Returns the number of rows that the aggregate has processed so far. This will include the current row, and so will always return at least 1.

    # File lib/sqlite3/database.rb, line 565
    def count
      @driver.aggregate_count( @func )
    end

set_error( error ) click to toggle source

Set the result of the function to the given error message. The function will then return that error.

    # File lib/sqlite3/database.rb, line 558
    def set_error( error )
      @driver.result_error( @func, error.to_s, -1 )
    end